Start a report run
curl --request POST \
--url https://api.hellotracks.com/v1/reports/run \
--header 'API-Key: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": true,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": [
"a1b2c3"
]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"formats": [
"xlsx",
"pdf"
]
}
'import requests
url = "https://api.hellotracks.com/v1/reports/run"
payload = {
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": True,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": ["a1b2c3"]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"formats": ["xlsx", "pdf"]
}
headers = {
"API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
request: {
report: 'timesheet',
view: 'perPerson',
period: 'lastWeek',
compare: true,
who: {kind: 'people', teamIds: [], memberUids: ['a1b2c3']},
places: {kind: 'all', field: '', value: '', teamIds: [], placeUids: []},
options: {},
format: 'xlsx'
},
formats: ['xlsx', 'pdf']
})
};
fetch('https://api.hellotracks.com/v1/reports/run', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hellotracks.com/v1/reports/run",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'request' => [
'report' => 'timesheet',
'view' => 'perPerson',
'period' => 'lastWeek',
'compare' => true,
'who' => [
'kind' => 'people',
'teamIds' => [
],
'memberUids' => [
'a1b2c3'
]
],
'places' => [
'kind' => 'all',
'field' => '',
'value' => '',
'teamIds' => [
],
'placeUids' => [
]
],
'options' => [
],
'format' => 'xlsx'
],
'formats' => [
'xlsx',
'pdf'
]
]),
CURLOPT_HTTPHEADER => [
"API-Key: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hellotracks.com/v1/reports/run"
payload := strings.NewReader("{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hellotracks.com/v1/reports/run")
.header("API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hellotracks.com/v1/reports/run")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"data": {
"run": {
"id": "6560000000000000000000a1",
"status": "queued",
"title": "Timesheet",
"source": "api",
"savedId": null,
"formats": [
"xlsx",
"pdf"
],
"createdTs": 1761901100000,
"completedTs": null,
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": true,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": [
"a1b2c3"
]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"files": []
}
},
"error": null,
"meta": {
"path": "/v1/reports/run",
"method": "POST"
}
}{
"data": null,
"error": {
"code": "invalid_request",
"message": "date must be YYYY-MM-DD"
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "invalid_api_key",
"message": "Invalid Hellotracks API key."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "forbidden",
"message": "No permission."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "throttled",
"message": "Too many requests."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "internal_error",
"message": "Hellotracks API is temporarily unavailable."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}Reports
Start a report run
Checks the request and starts making the report in the background in up to 3 formats. Answers 202 with the queued run; follow it with GET /reports/run/ until status is done (files with signed links) or failed. The body is , or the ReportRequest fields directly. Without formats, request.format or the report’s default format is used. Admins, operators and the company key may call it; workers get 403 permission_denied. jobs, form-answers and visit-report need a Dispatch plan (403 on a Location plan). Same envelope; errors here use the codes invalid_request (400), permission_denied (403) and internal_error (500).
POST
/
reports
/
run
Start a report run
curl --request POST \
--url https://api.hellotracks.com/v1/reports/run \
--header 'API-Key: <api-key>' \
--header 'Content-Type: application/json' \
--data '
{
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": true,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": [
"a1b2c3"
]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"formats": [
"xlsx",
"pdf"
]
}
'import requests
url = "https://api.hellotracks.com/v1/reports/run"
payload = {
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": True,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": ["a1b2c3"]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"formats": ["xlsx", "pdf"]
}
headers = {
"API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
request: {
report: 'timesheet',
view: 'perPerson',
period: 'lastWeek',
compare: true,
who: {kind: 'people', teamIds: [], memberUids: ['a1b2c3']},
places: {kind: 'all', field: '', value: '', teamIds: [], placeUids: []},
options: {},
format: 'xlsx'
},
formats: ['xlsx', 'pdf']
})
};
fetch('https://api.hellotracks.com/v1/reports/run', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hellotracks.com/v1/reports/run",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'request' => [
'report' => 'timesheet',
'view' => 'perPerson',
'period' => 'lastWeek',
'compare' => true,
'who' => [
'kind' => 'people',
'teamIds' => [
],
'memberUids' => [
'a1b2c3'
]
],
'places' => [
'kind' => 'all',
'field' => '',
'value' => '',
'teamIds' => [
],
'placeUids' => [
]
],
'options' => [
],
'format' => 'xlsx'
],
'formats' => [
'xlsx',
'pdf'
]
]),
CURLOPT_HTTPHEADER => [
"API-Key: <api-key>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.hellotracks.com/v1/reports/run"
payload := strings.NewReader("{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hellotracks.com/v1/reports/run")
.header("API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hellotracks.com/v1/reports/run")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"request\": {\n \"report\": \"timesheet\",\n \"view\": \"perPerson\",\n \"period\": \"lastWeek\",\n \"compare\": true,\n \"who\": {\n \"kind\": \"people\",\n \"teamIds\": [],\n \"memberUids\": [\n \"a1b2c3\"\n ]\n },\n \"places\": {\n \"kind\": \"all\",\n \"field\": \"\",\n \"value\": \"\",\n \"teamIds\": [],\n \"placeUids\": []\n },\n \"options\": {},\n \"format\": \"xlsx\"\n },\n \"formats\": [\n \"xlsx\",\n \"pdf\"\n ]\n}"
response = http.request(request)
puts response.read_body{
"data": {
"run": {
"id": "6560000000000000000000a1",
"status": "queued",
"title": "Timesheet",
"source": "api",
"savedId": null,
"formats": [
"xlsx",
"pdf"
],
"createdTs": 1761901100000,
"completedTs": null,
"request": {
"report": "timesheet",
"view": "perPerson",
"period": "lastWeek",
"compare": true,
"who": {
"kind": "people",
"teamIds": [],
"memberUids": [
"a1b2c3"
]
},
"places": {
"kind": "all",
"field": "",
"value": "",
"teamIds": [],
"placeUids": []
},
"options": {},
"format": "xlsx"
},
"files": []
}
},
"error": null,
"meta": {
"path": "/v1/reports/run",
"method": "POST"
}
}{
"data": null,
"error": {
"code": "invalid_request",
"message": "date must be YYYY-MM-DD"
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "invalid_api_key",
"message": "Invalid Hellotracks API key."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "forbidden",
"message": "No permission."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "throttled",
"message": "Too many requests."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}{
"data": null,
"error": {
"code": "internal_error",
"message": "Hellotracks API is temporarily unavailable."
},
"meta": {
"path": "/jobs",
"method": "GET"
}
}Authorizations
Body
application/json